BWFImportDescriptorImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model.impl

## Class BWFImportDescriptorImpl

- java.lang.Object
- - tv.amwa.maj.model.impl.InterchangeObjectImpl
  - - tv.amwa.maj.model.impl.EssenceDescriptorImpl
    - - tv.amwa.maj.model.impl.PhysicalDescriptorImpl
      - - tv.amwa.maj.model.impl.ImportDescriptorImpl
        - - tv.amwa.maj.model.impl.BWFImportDescriptorImpl

- All Implemented Interfaces:
    Serializable, Cloneable, MediaEntity, MetadataObject, XMLSerializable, BWFImportDescriptor, EssenceDescriptor, ImportDescriptor, InterchangeObject, PhysicalDescriptor

      @MediaClass(uuid1=218169601,
                  uuid2=257,
                  uuid3=20480,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="BWFImportDescriptor",
                  description="Specifies audio essence represented according to the Broadcast Wave specifications.",
                  symbol="BWFImportDescriptor")
      public class BWFImportDescriptorImpl
      extends ImportDescriptorImpl
      implements BWFImportDescriptor, Serializable, XMLSerializable, Cloneable

  Implements the description of audio essence that is formatted according the the Broadcast Wave Format specifications, which is a file essence source that is not directly manipulated by an AAF application.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `ObjectClassPropertyID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BWFImportDescriptorImpl()` Creates and initializes a new BWF import descriptor, which specifies audio data essence according to the Broadcast Wave specifications.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendUnknownBWFChunk(RIFFChunk chunk)` Append a RIFFChunk to end of the list of unknown BWF chunks of this BWF import descriptor.
    `void` | `clearUnknownBWFChunks()` Clear the unknown BWF chunks attached to this BWF import descriptor, omitting this optional property.
    `BWFImportDescriptor` | `clone()` Create a cloned copy of this interchange object.
    `int` | `countUnknownBWFChunks()` Returns the total number of unknown BWF chunks attached to this BWF import descriptor.
    `String` | `getBasicData()` Returns the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk.
    `String` | `getCodingHistory()` Returns the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk.
    `String` | `getCueSheet()` Returns the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk.
    `String` | `getEndOfModulation()` Returns the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk.
    `int` | `getFileSecurityReport()` Returns the file security code of the quality report of this BWF import descriptor.
    `int` | `getFileSecurityWave()` Returns the file security code of the BWF wave data of this BWF import descriptor.
    `String` | `getOperatorComment()` Returns the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk.
    `String` | `getQualityEvent()` Returns the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk.
    `String` | `getQualityParameter()` Returns the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk.
    `String` | `getStartOfModulation()` Returns the start of modulation data of this BWF import descriptor, which is taken from the start modulation data poperty of the associated <qlty> chunk.
    `RIFFChunk` | `getUnknownBWFChunkAt(int index)` Returns the RIFFChunk from the list of unknown BWF chunks of this BWF import descriptor at the given index.
    `List<RIFFChunk>` | `getUnknownBWFChunks()` Returns a copy of the list of unknown BWF chunks of this BWF import descriptor.
    `void` | `insertUnknownBWFChunkAt(int index, RIFFChunk chunk)` Insert a RIFFChunk into the list of unknown BWF chunks of this BWF import descriptor at the given index.
    `void` | `prependUnknownBWFChunk(RIFFChunk chunk)` Prepend a RIFFChunk to the beginning of the list of unknown BWF chunks of this BWF descriptor.
    `void` | `removeUnknownBWFChunkAt(int index)` Removes the RIFFChunk at the given index through the list of unknown BWF chunks of this BWF descriptor.
    `void` | `setBasicData(String basicData)` Sets the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk.
    `void` | `setCodingHistory(String codingHistory)` Sets the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk.
    `void` | `setCueSheet(String cueSheet)` Sets the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk.
    `void` | `setEndOfModulation(String endOfModulation)` Sets the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk.
    `void` | `setFileSecurityReport(Integer fileSecurityReport)` Set the file security code of the quality report of this BWF import descriptor.
    `void` | `setFileSecurityWave(Integer fileSecurityWave)` Sets the file security code of the BWF wave data of this BWF import descriptor.
    `void` | `setOperatorComment(String operatorComment)` Sets the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk.
    `void` | `setQualityEvent(String qualityEvent)` Sets the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk.
    `void` | `setQualityParameter(String qualityParameter)` Sets the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk.
    `void` | `setStartOfModulation(String startOfModulation)` Sets the start of modulation data of this BWF import descriptor, which is taken from the start modulation data property of the associated <qlty> chunk.

    - ### Methods inherited from class tv.amwa.maj.model.impl.EssenceDescriptorImpl

      `appendLocator, appendSubDescriptor, clearLocators, clearSubDescriptors, countLocators, countSubDescriptors, getComment, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `addApplicationPlugin, appendXMLChildren, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getLinkedGenerationIDString, getObjectClass, getPersistentID, getPersistentIndex, hashCode, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setLinkedGenerationIDString, setObjectClass, setPersistentID, setPersistentIndex, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.model.EssenceDescriptor

      `appendLocator, appendSubDescriptor, clearLocators, countLocators, countSubDescriptors, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

    - ### Methods inherited from interface tv.amwa.maj.io.xml.XMLSerializable

      `appendXMLChildren, getComment`

- - ### Constructor Detail

    - #### BWFImportDescriptorImpl

          public BWFImportDescriptorImpl()

      Creates and initializes a new BWF import descriptor, which specifies audio data essence according to the Broadcast Wave specifications.

  - ### Method Detail

    - #### getBasicData

          @MediaProperty(uuid1=67241218,
                         uuid2=513,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyBasicData",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15650,
                         symbol="QltyBasicData")
          public String getBasicData()
                                                                                                                                                                                                                                                                                                                                                                                   throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk. This property is optional.

      Specified by:
        `getBasicData` in interface `BWFImportDescriptor`
      Returns:
        Basic data of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional basic data property is not present in this BWF import descriptor.

    - #### setBasicData

          @MediaPropertySetter(value="QltyBasicData")
          public void setBasicData(String basicData)

      Description copied from interface: `BWFImportDescriptor`

      Sets the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setBasicData` in interface `BWFImportDescriptor`
      Parameters:
        `basicData` - Basic data of this BWF import descriptor.

    - #### getCodingHistory

          @MediaProperty(uuid1=67241218,
                         uuid2=257,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="BextCodingHistory",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15649,
                         symbol="BextCodingHistory")
          public String getCodingHistory()
                                                                                                                                                                                                                                                                                                                                                                                               throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk. This property is optional.

      Specified by:
        `getCodingHistory` in interface `BWFImportDescriptor`
      Returns:
        Coding history property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional coding history property is not present in this BWF import descriptor.

    - #### setCodingHistory

          @MediaPropertySetter(value="BextCodingHistory")
          public void setCodingHistory(String codingHistory)

      Description copied from interface: `BWFImportDescriptor`

      Sets the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setCodingHistory` in interface `BWFImportDescriptor`
      Parameters:
        `codingHistory` - Coding history property of this BWF import descriptor.

    - #### getCueSheet

          @MediaProperty(uuid1=67241218,
                         uuid2=2049,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyCueSheet",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15656,
                         symbol="QltyCueSheet")
          public String getCueSheet()
                                                                                                                                                                                                                                                                                                                                                                                 throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk. This property is optional

      Specified by:
        `getCueSheet` in interface `BWFImportDescriptor`
      Returns:
        Cue sheet property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional cue sheet property is not present in this BWF import descriptor.

    - #### setCueSheet

          @MediaPropertySetter(value="QltyCueSheet")
          public void setCueSheet(String cueSheet)

      Description copied from interface: `BWFImportDescriptor`

      Sets the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setCueSheet` in interface `BWFImportDescriptor`
      Parameters:
        `cueSheet` - Cue sheet property of this BWF import descriptor.

    - #### getEndOfModulation

          @MediaProperty(uuid1=67241218,
                         uuid2=1281,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyEndOfModulation",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15653,
                         symbol="QltyEndOfModulation")
          public String getEndOfModulation()
                                                                                                                                                                                                                                                                                                                                                                                                      throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk. This property is optional.

      Specified by:
        `getEndOfModulation` in interface `BWFImportDescriptor`
      Returns:
        End of modulation property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional end of modulation property is not present in this BWF import descriptor.

    - #### setEndOfModulation

          @MediaPropertySetter(value="QltyEndOfModulation")
          public void setEndOfModulation(String endOfModulation)

      Description copied from interface: `BWFImportDescriptor`

      Sets the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setEndOfModulation` in interface `BWFImportDescriptor`
      Parameters:
        `endOfModulation` - End of modulation property of this BWF import descriptor.

    - #### getFileSecurityReport

          @MediaProperty(uuid1=67240706,
                         uuid2=1280,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyFileSecurityReport",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15637,
                         symbol="QltyFileSecurityReport")
          public int getFileSecurityReport()
                                                                                                                                                                                                                                                                                                                                                                                                       throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the file security code of the quality report of this BWF import descriptor. This property is optional.

      Specified by:
        `getFileSecurityReport` in interface `BWFImportDescriptor`
      Returns:
        File security code of the quality report of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional file security code value is not present in this BWF import descriptor.

    - #### setFileSecurityReport

          @MediaPropertySetter(value="QltyFileSecurityReport")
          public void setFileSecurityReport(Integer fileSecurityReport)

      Description copied from interface: `BWFImportDescriptor`

      Set the file security code of the quality report of this BWF import descriptor. This property is optional and can be omitted by setting its value to `null`.

      Specified by:
        `setFileSecurityReport` in interface `BWFImportDescriptor`
      Parameters:
        `fileSecurityReport` - File security code of the quality report of this BWF import descriptor.

    - #### getFileSecurityWave

          @MediaProperty(uuid1=67240706,
                         uuid2=1536,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyFileSecurityWave",
                         typeName="UInt32",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15638,
                         symbol="QltyFileSecurityWave")
          public int getFileSecurityWave()
                                                                                                                                                                                                                                                                                                                                                                                                 throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the file security code of the BWF wave data of this BWF import descriptor. This property is optional.

      Specified by:
        `getFileSecurityWave` in interface `BWFImportDescriptor`
      Returns:
        File security code of the BWF wave data of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional file security wave property is not present in this BWF import descriptor.

    - #### setFileSecurityWave

          @MediaPropertySetter(value="QltyFileSecurityWave")
          public void setFileSecurityWave(Integer fileSecurityWave)

      Description copied from interface: `BWFImportDescriptor`

      Sets the file security code of the BWF wave data of this BWF import descriptor. This property is optional and can be omitted by setting its value to `null`.

      Specified by:
        `setFileSecurityWave` in interface `BWFImportDescriptor`
      Parameters:
        `fileSecurityWave` - File security code of the BWF wave data of this BWF import descriptor.

    - #### getOperatorComment

          @MediaProperty(uuid1=67241218,
                         uuid2=1793,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyOperatorComment",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15655,
                         symbol="QltyOperatorComment")
          public String getOperatorComment()
                                                                                                                                                                                                                                                                                                                                                                                                      throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk. This property is optional.

      Specified by:
        `getOperatorComment` in interface `BWFImportDescriptor`
      Returns:
        Operator comment property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional operator comment property is not present in this BWF import descriptor.

    - #### setOperatorComment

          @MediaPropertySetter(value="QltyOperatorComment")
          public void setOperatorComment(String operatorComment)

      Description copied from interface: `BWFImportDescriptor`

      Sets the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setOperatorComment` in interface `BWFImportDescriptor`
      Parameters:
        `operatorComment` - Operator comment of this BWF import descriptor.

    - #### getQualityEvent

          @MediaProperty(uuid1=67241218,
                         uuid2=1025,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyQualityEvent",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15652,
                         symbol="QltyQualityEvent")
          public String getQualityEvent()
                                                                                                                                                                                                                                                                                                                                                                                             throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk. This property is optional.

      Specified by:
        `getQualityEvent` in interface `BWFImportDescriptor`
      Returns:
        Quality event data property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional quality event property is not present in this BWF import descriptor.

    - #### setQualityEvent

          @MediaPropertySetter(value="QltyQualityEvent")
          public void setQualityEvent(String qualityEvent)

      Description copied from interface: `BWFImportDescriptor`

      Sets the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setQualityEvent` in interface `BWFImportDescriptor`
      Parameters:
        `qualityEvent` - Quality event data property of this BWF import descriptor.

    - #### getQualityParameter

          @MediaProperty(uuid1=67241218,
                         uuid2=1537,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyQualityParameter",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15654,
                         symbol="QltyQualityParameter")
          public String getQualityParameter()
                                                                                                                                                                                                                                                                                                                                                                                                         throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk. This property is optional.

      Specified by:
        `getQualityParameter` in interface `BWFImportDescriptor`
      Returns:
        Quality parameter property of this BWF import descriptor
      Throws:
        `PropertyNotPresentException` - The optional quality parameter property is not present in this BWF import descriptor.

    - #### setQualityParameter

          @MediaPropertySetter(value="QltyQualityParameter")
          public void setQualityParameter(String qualityParameter)

      Description copied from interface: `BWFImportDescriptor`

      Sets the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setQualityParameter` in interface `BWFImportDescriptor`
      Parameters:
        `qualityParameter` - Quality parameter property of this BWF import descriptor.

    - #### getStartOfModulation

          @MediaProperty(uuid1=67241218,
                         uuid2=769,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,5},
                         definedName="QltyStartOfModulation",
                         typeName="UTF16String",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15651,
                         symbol="QltyStartOfModulation")
          public String getStartOfModulation()
                                                                                                                                                                                                                                                                                                                                                                                                           throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns the start of modulation data of this BWF import descriptor, which is taken from the start modulation data poperty of the associated <qlty> chunk. This property is optional.

      Specified by:
        `getStartOfModulation` in interface `BWFImportDescriptor`
      Returns:
        Start of modulation data of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional start of modulation property is not present in this BWF import descriptor.

    - #### setStartOfModulation

          @MediaPropertySetter(value="QltyStartOfModulation")
          public void setStartOfModulation(String startOfModulation)

      Description copied from interface: `BWFImportDescriptor`

      Sets the start of modulation data of this BWF import descriptor, which is taken from the start modulation data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Specified by:
        `setStartOfModulation` in interface `BWFImportDescriptor`
      Parameters:
        `startOfModulation` - Start of modulation data of this BWF import descriptor.

    - #### getUnknownBWFChunks

          @MediaProperty(uuid1=100729092,
                         uuid2=1551,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,8},
                         definedName="UnknownBWFChunks",
                         typeName="RIFFChunkStrongReferenceVector",
                         optional=true,
                         uniqueIdentifier=false,
                         pid=15667,
                         symbol="UnknownBWFChunks")
          public List<RIFFChunk> getUnknownBWFChunks()
                                                                                                                                                                                                                                                                                                                                                                                                                              throws PropertyNotPresentException

      Description copied from interface: `BWFImportDescriptor`

      Returns a copy of the list of unknown BWF chunks of this BWF import descriptor. This is an optional property.

      Specified by:
        `getUnknownBWFChunks` in interface `BWFImportDescriptor`
      Returns:
        Shallow copy of the list of unknown BWF chunks of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional list of unknown BWF chunks is not present for this BWF import descriptor.
      See Also:
        `TypeDefinitions.RIFFChunkStrongReferenceVector`

    - #### appendUnknownBWFChunk

          @MediaListAppend(value="UnknownBWFChunks")
          public void appendUnknownBWFChunk(RIFFChunk chunk)
                                                                                throws NullPointerException,
                                                                                       ObjectAlreadyAttachedException

      Description copied from interface: `BWFImportDescriptor`

      Append a RIFFChunk to end of the list of unknown BWF chunks of this BWF import descriptor.

      Specified by:
        `appendUnknownBWFChunk` in interface `BWFImportDescriptor`
      Parameters:
        `chunk` - Chunk to append to the current list.
      Throws:
        `NullPointerException` - The chunk argument is `null`.
        `ObjectAlreadyAttachedException` - The chunk is already contained within the list of unknown BWF chunks of this BWF import descriptor.

    - #### countUnknownBWFChunks

          @MediaPropertyCount(value="UnknownBWFChunks")
          public int countUnknownBWFChunks()

      Description copied from interface: `BWFImportDescriptor`

      Returns the total number of unknown BWF chunks attached to this BWF import descriptor.

      Specified by:
        `countUnknownBWFChunks` in interface `BWFImportDescriptor`
      Returns:
        Number of unknown BWF chunks attached to this BWF descriptor.

    - #### clearUnknownBWFChunks

          @MediaPropertyClear(value="UnknownBWFChunks")
          public void clearUnknownBWFChunks()

      Description copied from interface: `BWFImportDescriptor`

      Clear the unknown BWF chunks attached to this BWF import descriptor, omitting this optional property.

      Specified by:
        `clearUnknownBWFChunks` in interface `BWFImportDescriptor`

    - #### getUnknownBWFChunkAt

          @MediaListGetAt(value="UnknownBWFChunks")
          public RIFFChunk getUnknownBWFChunkAt(int index)
                                                                                   throws IndexOutOfBoundsException

      Description copied from interface: `BWFImportDescriptor`

      Returns the RIFFChunk from the list of unknown BWF chunks of this BWF import descriptor at the given index.

      Specified by:
        `getUnknownBWFChunkAt` in interface `BWFImportDescriptor`
      Parameters:
        `index` - Index of the chunk to retrieve.
      Returns:
        Chunk at the given index into the list of unknown BWF chunks of this BWF import descriptor.
      Throws:
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of unknown BWF chunks of this BWF import descriptor.

    - #### insertUnknownBWFChunkAt

          @MediaListInsertAt(value="UnknownBWFChunks")
          public void insertUnknownBWFChunkAt(int index,
                                                                                           RIFFChunk chunk)
                                                                                    throws NullPointerException,
                                                                                           IndexOutOfBoundsException,
                                                                                           ObjectAlreadyAttachedException

      Description copied from interface: `BWFImportDescriptor`

      Insert a RIFFChunk into the list of unknown BWF chunks of this BWF import descriptor at the given index. Chunks already existing at the given and higher indices will be moved to the next higher index to accommodate the new chunk.

      Specified by:
        `insertUnknownBWFChunkAt` in interface `BWFImportDescriptor`
      Parameters:
        `index` - Index through the list of unknown BWF chunks at which to insert the additional chunk.
        `chunk` - Chunk to insert at the given index.
      Throws:
        `NullPointerException` - The chunk argument is `null`.
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of unknown BWF chunks of this BWF import descriptor.
        `ObjectAlreadyAttachedException` - The given chunk is already contained in the list of unknown BWF chunks of this BWF import descriptor.

    - #### prependUnknownBWFChunk

          @MediaListPrepend(value="UnknownBWFChunks")
          public void prependUnknownBWFChunk(RIFFChunk chunk)
                                                                                  throws NullPointerException,
                                                                                         ObjectAlreadyAttachedException

      Description copied from interface: `BWFImportDescriptor`

      Prepend a RIFFChunk to the beginning of the list of unknown BWF chunks of this BWF descriptor.

      Specified by:
        `prependUnknownBWFChunk` in interface `BWFImportDescriptor`
      Parameters:
        `chunk` - Chunk to prepend to the current list.
      Throws:
        `NullPointerException` - The chunk argument is `null`.
        `ObjectAlreadyAttachedException` - The The chunk is already contained within the list of unknown BWF chunks of this BWF import descriptor.

    - #### removeUnknownBWFChunkAt

          @MediaListRemoveAt(value="UnknownBWFChunks")
          public void removeUnknownBWFChunkAt(int index)
                                                                                    throws IndexOutOfBoundsException

      Description copied from interface: `BWFImportDescriptor`

      Removes the RIFFChunk at the given index through the list of unknown BWF chunks of this BWF descriptor. Chunks already existing at indices higher than the given index will be moved to the next lower index to fill the gap left by the removal.

      Specified by:
        `removeUnknownBWFChunkAt` in interface `BWFImportDescriptor`
      Parameters:
        `index` - Index of the chunk to remove.
      Throws:
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of unknown BWF chunks of this BWF import descriptor.

    - #### clone

          public BWFImportDescriptor clone()

      Description copied from interface: `InterchangeObject`

      Create a cloned copy of this interchange object.

      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `BWFImportDescriptor`
      Specified by:
        `clone` in interface `EssenceDescriptor`
      Specified by:
        `clone` in interface `ImportDescriptor`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `PhysicalDescriptor`
      Overrides:
        `clone` in class `ImportDescriptorImpl`
      Returns:
        Cloned copy of this interchange object.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.